#define MaxNumVertices 100

typedef int elem;

typedef struct no_lista {
        elem v;
        int peso;
        struct no_lista *prox;
} no_lista;

typedef struct {
        no_lista *inicio, *fim;
} no_vertice;

typedef struct {
        no_vertice Adj[MaxNumVertices+1];
        int NumVertices;
} Grafo;

typedef enum {
        branco, cinza, preto
} TipoCor;


void criar(Grafo*, int, int*);
void inserir(Grafo*, int, int, elem, int*);
int existe_aresta(Grafo*, int, int, int*);
void retirar_aresta(Grafo*, int, int, elem*, int*);
void liberar_memoria(Grafo*);
void gerar_grafo_transposto(Grafo*, Grafo*, int*);
void imprimir(Grafo*);
void busca_largura(Grafo*);
void busca_profundidade(Grafo*);
